package me.km;

import java.util.List;
import me.km.networking.ItemStackDisplayGui;
import me.km.networking.PlayerDisplayGui;
import me.km.networking.PlayerHeadGui;
import me.km.networking.StatusDisplayGui;
import net.minecraft.item.Item;
import net.minecraft.item.ArmorItem;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.CompoundNBT;
import net.minecraft.util.text.ITextComponent;
import net.minecraft.util.text.StringTextComponent;
import net.minecraft.util.text.TextFormatting;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.client.event.RenderGameOverlayEvent;
import net.minecraftforge.event.entity.player.ItemTooltipEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.common.gameevent.TickEvent;

@OnlyIn(Dist.CLIENT)
public class ClientEvents 
{   
    boolean once = true;
    
    @SubscribeEvent
    public void onClientTick(TickEvent.ClientTickEvent e)
    {
        if(e.phase == TickEvent.Phase.END)
        {
            StatusDisplayGui.INSTANCE.tick();
        }  
    }
    
    @SubscribeEvent
    public void onRenderGui(RenderGameOverlayEvent.Pre e)
    {
        if(e.getType() == RenderGameOverlayEvent.ElementType.POTION_ICONS)
        {
            e.setCanceled(true);
        }
    }
    
    @SubscribeEvent
    public void onRenderGui(RenderGameOverlayEvent.Post e)
    {
        if(e.getType() == RenderGameOverlayEvent.ElementType.EXPERIENCE)
        {
            PlayerDisplayGui.INSTANCE.paint();
            StatusDisplayGui.INSTANCE.paint();
            PlayerHeadGui.INSTANCE.paint();
            ItemStackDisplayGui.INSTANCE.paint();
        }
    }
    
    // ToDo: Event is missing?
    //@SubscribeEvent
    //public void onRenderGui(FMLNetworkEvent.ClientDisconnectionFromServerEvent e)
    //{
    //    PlayerDisplayGui.INSTANCE.clear();
    //    StatusDisplayGui.INSTANCE.clear();
    //    PlayerHeadGui.INSTANCE.clear();
    //    ItemStackDisplayGui.INSTANCE.clear();
    //    ItemStackDisplayGui.INSTANCE.setActive(false);
    //}
    
    @SubscribeEvent
    public void showingTooltip(ItemTooltipEvent e) 
    {
        ItemStack stack = e.getItemStack();
        Item item = stack.getItem();
        if(item instanceof ArmorItem)
        {
            CompoundNBT com = stack.getTag();
            if(com != null && com.contains("magic"))
            {
                int magic = com.getInt("magic");
                if(magic != 0)
                {
                    List<ITextComponent> list = e.getToolTip();
                    String s = TextFormatting.BLUE + " +";
                    for(int i = 0; i < list.size(); i++)
                    {
                        if(list.get(i).getString().startsWith(s))
                        {
                            list.add(i, new StringTextComponent(String.format("%s +%d Magic Armor", TextFormatting.BLUE, magic)));
                            break;
                        }
                    }
                }
            }
        }
    }
}
