package me.km.entities;

import me.km.KajetansMod;
import net.minecraft.entity.EntityClassification;
import net.minecraft.entity.EntityType;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.registries.IForgeRegistry;

public class ModEntities 
{
    public static final EntityType<EntityHuman> HUMAN = 
            (EntityType<EntityHuman>) EntityType.Builder.create(EntityHuman::new, EntityClassification.CREATURE)
                    .size(0.6F, 1.8F)
                    .build(String.format("%s:human", KajetansMod.MODID))
                    .setRegistryName(KajetansMod.MODID, "human");
    public static final EntityType<EntityNobody> NOBODY = 
            (EntityType<EntityNobody>) EntityType.Builder.create(EntityNobody::new, EntityClassification.MISC)
                    .size(0.0f, 0.0f)
                    .build(String.format("%s:nobody", KajetansMod.MODID))
                    .setRegistryName(KajetansMod.MODID, "nobody");
    public static final EntityType<EntityBrownBear> BROWN_BEAR = 
            (EntityType<EntityBrownBear>) EntityType.Builder.create(EntityBrownBear::new, EntityClassification.CREATURE)
                    .size(1.4f, 1.4f)
                    .build(String.format("%s:bear/brownbear", KajetansMod.MODID))
                    .setRegistryName(KajetansMod.MODID, "bear/brownbear");
    public static final EntityType<EntityBlackBear> BLACK_BEAR = 
            (EntityType<EntityBlackBear>) EntityType.Builder.create(EntityBlackBear::new, EntityClassification.CREATURE)
                    .size(1.4f, 1.4f)
                    .build(String.format("%s:bear/blackbear", KajetansMod.MODID))
                    .setRegistryName(KajetansMod.MODID, "bear/blackbear");
    
    public static void init(IForgeRegistry<EntityType<?>> r)
    {
        r.register(HUMAN);
        r.register(NOBODY);
        r.register(BROWN_BEAR);
        r.register(BLACK_BEAR); 
    }
    
    @OnlyIn(Dist.CLIENT)
    public static void initClient() 
    {
        RenderingRegistry.registerEntityRenderingHandler(EntityBrownBear.class, (rm) -> 
        {
            return new RenderBrownBear();
        });
        RenderingRegistry.registerEntityRenderingHandler(EntityBlackBear.class, (rm) -> 
        {
            return new RenderBlackBear();
        });
        RenderingRegistry.registerEntityRenderingHandler(EntityHuman.class, (rm) -> 
        {
            return new RenderHuman();
        });
        RenderingRegistry.registerEntityRenderingHandler(EntityNobody.class, (rm) -> 
        {
            return new RenderNobody();
        });
    }
}
