package me.km.networking;

import java.util.function.Supplier;
import me.km.entities.EntityHuman;
import net.minecraft.client.Minecraft;
import net.minecraft.entity.Entity;
import net.minecraft.network.PacketBuffer;
import net.minecraftforge.fml.network.NetworkEvent;

public class HumanScaleUpdate
{
    private int humanId;
    private float scale;
    private byte slim;
    
    public HumanScaleUpdate() 
    {
        humanId = -1;
        scale = 1;
        slim = 0;
    }
    
    public HumanScaleUpdate(EntityHuman h) 
    {
        humanId = h.getEntityId();
        scale = h.getScale();
        slim = h.getSlim();
    }
    
    public static void writeBytes(HumanScaleUpdate hsu, PacketBuffer buf)
    {
        buf.writeInt(hsu.humanId);
        buf.writeFloat(hsu.scale);
        buf.writeByte(hsu.slim);
    }
    
    public static HumanScaleUpdate fromBytes(PacketBuffer buf)
    {
        HumanScaleUpdate hsu = new HumanScaleUpdate();
        hsu.humanId = buf.readInt();
        hsu.scale = buf.readFloat();
        hsu.slim = buf.readByte();
        return hsu;
    }
    
    public static void handle(HumanScaleUpdate hsu, Supplier<NetworkEvent.Context> context)
    {
        context.get().enqueueWork(() -> 
        {
            Entity ent = Minecraft.getInstance().world.getEntityByID(hsu.humanId);
            if(ent == null || !(ent instanceof EntityHuman))
            {
                return;
            }
            EntityHuman h = (EntityHuman) ent;
            h.setScale(hsu.scale);
            h.setSlim(hsu.slim);
        });
        context.get().setPacketHandled(true);
    }
}
