package me.km.world;

import java.util.Random;
import me.km.blocks.ModBlocks;
import net.minecraft.block.BlockState;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraft.world.chunk.AbstractChunkProvider;
import net.minecraft.world.dimension.DimensionType;
import net.minecraft.world.gen.ChunkGenerator;
import net.minecraft.world.gen.feature.OreFeature;
import net.minecraft.world.gen.feature.OreFeatureConfig;
import net.minecraftforge.fml.common.IWorldGenerator;

public class ModWorldGeneration implements IWorldGenerator
{
    @Override
    public void generate(Random r, int cX, int cZ, World w, ChunkGenerator cg, AbstractChunkProvider cp)
    {
        DimensionType type = w.getDimension().getType();
        if(type != DimensionType.NETHER && type != DimensionType.THE_END) 
        {
            generateOverworld(r, cX, cZ, w, cg, cp);
	}
    }
	
    private void generateOverworld(Random r, int chunkX, int chunkZ, World w, ChunkGenerator cg, AbstractChunkProvider cp) 
    {
        generateOre(cg, ModBlocks.copperOre.getDefaultState(), w, r, 
                chunkX << 4, chunkZ << 4, 0, 128, 9, 25);
        generateOre(cg, ModBlocks.tinOre.getDefaultState(), w, r, 
                chunkX << 4, chunkZ << 4, 0, 96, 8, 12);
        generateOre(cg, ModBlocks.silverOre.getDefaultState(), w, r, 
                chunkX << 4, chunkZ << 4, 0, 64, 8, 3);
    } 
    
    private void generateOre(ChunkGenerator cg, BlockState ore, World w, Random r, int x, int z, 
            int minY, int maxY, int size, int chances) 
    {
        int deltaY = maxY - minY;
        BlockPos pos;
        OreFeatureConfig config = new OreFeatureConfig(OreFeatureConfig.FillerBlockType.NATURAL_STONE, ore, size);
        OreFeature generator = new OreFeature(OreFeatureConfig::deserialize);
        for(int i = 0; i < chances; i++) 
        {
            // generates position in chunk
            pos = new BlockPos(x + r.nextInt(16), minY + r.nextInt(deltaY), z + r.nextInt(16));
            generator.place(w, cg, r, pos, config);
        }
    }
}